import { WidgetContext } from "./WidgetInstance";
declare type ComponentObj = {
    [key: string]: any;
};
declare type AsyncComponentObj = {
    [key: string]: string;
};
interface ObserverConstructor {
    lazyImport: (componentName: string) => Promise<any>;
    plugins: (ctx: WidgetContext<unknown>) => {
        [x: string]: (...args: any[]) => any;
    };
    widgets?: ComponentObj;
    asyncWidgets?: AsyncComponentObj;
    rootElement?: string;
    selector?: string;
    logs?: boolean;
}
export declare class Observer {
    private readonly widgets;
    private readonly asyncWidgets;
    private readonly rootElement;
    private readonly plugins;
    private readonly selector;
    readonly lazyImport: (componentName: string) => Promise<any>;
    readonly shouldLog: boolean;
    constructor({ lazyImport, plugins, widgets, asyncWidgets, rootElement, selector, logs, }: ObserverConstructor);
    get COMPONENT_LIST(): string[];
    afterNodeDeleted(removedNodes: HTMLElement[]): void;
    afterNodeAdded(addedNodes: HTMLElement[]): void;
    observeDomChanges(target: HTMLElement): Promise<void>;
    findWidgets(target: HTMLElement): HTMLElement[];
    importWidgets(target: HTMLElement): Promise<void>;
    init(): Promise<void>;
}
export {};
