export declare type WidgetContext<Props> = {
    id: string;
    $el: HTMLElement;
    props: Props;
    propEffect: (propName: keyof Props, effect: () => void) => any;
};
export declare type WidgetFunction<T, S> = (ctx: WidgetContext<T>, plugins: S) => void | (() => void);
declare type PluginFunction<T, S> = (ctx: WidgetContext<T>) => S;
export declare class WidgetInstance<Props, S> {
    private readonly plugins;
    private readonly widgetHandlerFunction;
    props: Props;
    readonly $el: HTMLElement;
    effects: any;
    observables: any;
    readonly id: string;
    readonly name: string;
    destroy: () => void;
    constructor(htmlEl: HTMLElement, handler: WidgetFunction<Props, S>, plugins: PluginFunction<Props, S>);
    propEffect: (propName: keyof Props, effect: () => void) => any[];
    watchAttributes(): void;
    private get CONTEXT();
    private get PLUGINS();
    private setWidgetIdAttribute;
    private collectProps;
    private init;
}
export {};
